// hierlist.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "hierlist.h"

#include "mainfrm.h"
#include "hierldoc.h"
#include "hierlvw.h"

#include "ctl3d.h"

#if !defined(LSTBOXEX_H)
 #include "lstboxex.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHierlistApp

BEGIN_MESSAGE_MAP(CHierlistApp, CWinApp)
	//{{AFX_MSG_MAP(CHierlistApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHierlistApp construction

CHierlistApp::CHierlistApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CHierlistApp object

CHierlistApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CHierlistApp initialization

BOOL CHierlistApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	Ctl3dRegister(AfxGetInstanceHandle());
	Ctl3dAutoSubclass(AfxGetInstanceHandle());
		
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	AddDocTemplate(new CMultiDocTemplate(IDR_HIERLITYPE,
			RUNTIME_CLASS(CHierlistDoc),
			RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
			RUNTIME_CLASS(CHierlistView)));

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	m_pMainWnd = pMainFrame;

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}
	
	return TRUE;
}

int CHierlistApp::ExitInstance()
{
	Ctl3dUnregister(AfxGetInstanceHandle());
	
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CButton	m_Lines;
	CTestListEx   m_TestListEx;
	CTestHierList m_TestHierList;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnClickedLines();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	CMainFrame* mf = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	ASSERT(mf && mf->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	m_TestHierList.AttachResources( &mf->m_ListBoxRes1 );
	m_TestListEx.AttachResources( &mf->m_ListBoxRes1 ); 
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINES, m_Lines);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_LINES, OnClickedLines)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CHierlistApp::OnAppAbout()
{
	CAboutDlg dlg;
	dlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CHierlistApp commands

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	CenterWindow();

	VERIFY(m_TestHierList.SubclassDlgItem(IDC_HIER,this));
	VERIFY(m_TestListEx.SubclassDlgItem(IDC_LIST,this));

	m_TestHierList.DialogInit();
	m_TestListEx.DialogInit();

	return TRUE;
}

void CAboutDlg::OnClickedLines()
{
	m_TestHierList.EnableLines(m_Lines.GetCheck());	
}
