// testlist.cpp : implementation file
//

#include "stdafx.h"
#include "hierlist.h"
#include "testlist.h"

#include "dragdrop.h"

#include "strstream.h"
#include "iomanip.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestListEx

CTestListEx::CTestListEx()
{
	hCopy = AfxGetApp()->LoadCursor(IDC_COPY);
	hMove = AfxGetApp()->LoadCursor(IDC_MOVE);
}

CTestListEx::~CTestListEx()
{
}


BEGIN_MESSAGE_MAP(CTestListEx, CListBoxEx)
	//{{AFX_MSG_MAP(CTestListEx)
	ON_WM_CREATE()
	ON_REGISTERED_MESSAGE( WM_DROP,    OnDrop )
	ON_REGISTERED_MESSAGE( WM_CANDROP, OnCanDrop )
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestListEx message handlers


int CTestListEx::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CListBoxEx::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	Initialise();
		
	return 0;
}
 
void CTestListEx::Initialise()
{
	for( int i=0; i<20; i++ )
	{
		// just add what you like to CListBoxEx
		AddString( (LPCSTR)i );
	}
}

HCURSOR CTestListEx::GetCursor( eLbExCursor e ) const
{
	switch(e)
	{
	case LbExCopyMultiple:
	case LbExCopySingle:
		return hCopy;
	case LbExMoveSingle:
	case LbExMoveMultiple:
		return hMove;
	}
	return HCURSOR(NULL);
}
		 
void CTestListEx::DialogInit()
{
	OnCreate(NULL);
}

int CTestListEx::CompareItem(LPCOMPAREITEMSTRUCT lpCIS)
{
	return 0;
}

void CTestListEx::DroppedItemsOnWindowAt( CWnd* pWnd, const CPoint& p, BOOL bCopy )
{
	CDragStruct drag( this, p, bCopy, 0, GetSelCount() );

	ReleaseCapture();		
	if( pWnd->SendMessage( WM_DROP, 0, (LPARAM)&drag ) ) // wparam and lparam to pass drop info 
	{
	}		
}

LRESULT CTestListEx::OnCanDrop( WPARAM, LPARAM )
{
	return TRUE;
}

LRESULT CTestListEx::OnDrop( WPARAM, LPARAM )
{
	AfxMessageBox( "Drop in!" );
	return TRUE;
}

void CTestListEx::DrawItemEx( CListBoxExDrawStruct& ds )
{
	CDC* pBmpDC  = (CDC*)&ds.m_pResources->DcBitMap(); // naughty cast - should BitBlt take a const CDC* ?
	int bmh = ds.m_pResources->BitmapHeight();
	int bmw = ds.m_pResources->BitmapWidth();

	// select bitmap from resource

	int bm_h = (ds.m_Sel)?0:bmh;
	int bm_w = 0;
	ds.m_pDC->BitBlt( ds.m_Rect.left+1, ds.m_Rect.top, bmw, bmh, pBmpDC, bm_w, bm_h, SRCCOPY );

	// just for testing
	char buf[16];
	ostrstream o(buf,sizeof(buf));
	o << "Item " << ds.m_ItemData << ends;
		
	ds.m_pDC->TextOut(ds.m_Rect.left+bmw+3,ds.m_Rect.top,buf);
}

BOOL CTestListEx::CanDrop( CWnd* pWnd, const CPoint& p, BOOL bCopy ) 
{
	return (BOOL)pWnd->SendMessage( WM_CANDROP ); // wpararm and lparam to pass drag query info 
}

void CTestListEx::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	AfxMessageBox( "Do something else" );
	SetFocus();	
}
